Unit de21eu_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure de21eu(var A :Array of Extended; var LU :Array of Extended;
                N :Integer; IA :Integer; NDIG :Integer;
                var D1 :Extended; var D2 :Extended;
                var IPVT :Array of Extended; var EQUIL :Array of Extended;
                var WA :Extended; var IERR :Integer);

implementation

procedure de21eu(var A :Array of Extended; var LU :Array of Extended;
                N :Integer; IA :Integer; NDIG :Integer;
                var D1 :Extended; var D2 :Extended;
                var IPVT :Array of Extended; var EQUIL :Array of Extended;
                var WA :Extended; var IERR :Integer);
var
IDGT,I,J,JM1,K,IMAX,JP1,IM1 :Integer;
RN,WREL,BIGA,BIG,P,SUM,AI,WI,T,TEST,Q :Extended;
const
ZERO :Extended = 0.0e0;
ONE :Extended = 1.0e0;
FOUR :Extended = 4.0e0;
SIXTN :Extended = 16.0e0;
SIXTH :Extended = 0.0625e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24;
begin
IDGT := NDIG;
IERR := 0;
RN := N;
WREL := ZERO;
D1 := ONE;
D2 := ZERO;
BIGA := ZERO;
for I:=1 to N do
 begin
  BIG := ZERO;
  for J:=1 to N do
   begin
    P := A[(I-1)+(J-1)*IA];
    LU[(I-1)+(J-1)*IA] := P;
    P := Abs(P);
    if ( P > BIG ) 
     then BIG := P;
_1:
   end;
  if ( BIG > BIGA ) 
   then BIGA := BIG;
  if ( BIG = ZERO ) 
   then goto _22;
  EQUIL[I-1] := ONE/BIG;
_2:
 end;
for J:=1 to N do
 begin
  JM1 := J-1;
  if ( JM1 < 1 ) 
   then goto _8;
  for I:=1 to JM1 do
   begin
    SUM := LU[(I-1)+(J-1)*IA];
    IM1 := I-1;
    if ( IDGT = 0 ) 
     then goto _5;
    AI := Abs(SUM);
    WI := ZERO;
    if ( IM1 < 1 ) 
     then goto _4;
    for K:=1 to IM1 do
     begin
      T := LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
      SUM := SUM-T;
      WI := WI+Abs(T);
_3:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_4:
    WI := WI+Abs(SUM);
    if ( AI = ZERO ) 
     then AI := BIGA;
    TEST := WI/AI;
    if ( TEST > WREL ) 
     then WREL := TEST;
    goto _7;
_5:
    if ( IM1 < 1 ) 
     then goto _7;
    for K:=1 to IM1 do
     begin
      SUM := SUM-LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
_6:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_7:
   end;
_8:
  P := ZERO;
  for I:=J to N do
   begin
    SUM := LU[(I-1)+(J-1)*IA];
    if ( IDGT = 0 ) 
     then goto _11;
    AI := Abs(SUM);
    WI := ZERO;
    if ( JM1 < 1 ) 
     then goto _10;
    for K:=1 to JM1 do
     begin
      T := LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
      SUM := SUM-T;
      WI := WI+Abs(T);
_9:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_10:
    WI := WI+Abs(SUM);
    if ( AI = ZERO ) 
     then AI := BIGA;
    TEST := WI/AI;
    if ( TEST > WREL ) 
     then WREL := TEST;
    goto _13;
_11:
    if ( JM1 < 1 ) 
     then goto _13;
    for K:=1 to JM1 do
     begin
      SUM := SUM-LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
_12:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_13:
    Q := EQUIL[I-1]*Abs(SUM);
    if ( P >= Q ) 
     then goto _14;
    P := Q;
    IMAX := I;
_14:
   end;
  if ( RN+P = RN ) 
   then goto _22;
  if ( J = IMAX ) 
   then goto _16;
  D1 := -D1;
  for K:=1 to N do
   begin
    P := LU[(IMAX-1)+(K-1)*IA];
    LU[(IMAX-1)+(K-1)*IA] := LU[(J-1)+(K-1)*IA];
    LU[(J-1)+(K-1)*IA] := P;
_15:
   end;
  EQUIL[IMAX-1] := EQUIL[J-1];
_16:
  IPVT[J-1] := IMAX;
  D1 := D1*LU[(J-1)+(J-1)*IA];
_17:
  if ( Abs(D1) <= ONE ) 
   then goto _18;
  D1 := D1*SIXTH;
  D2 := D2+FOUR;
  goto _17;
_18:
  if ( Abs(D1) >= SIXTH ) 
   then goto _19;
  D1 := D1*SIXTN;
  D2 := D2-FOUR;
  goto _18;
_19:
  JP1 := J+1;
  if ( JP1 > N ) 
   then goto _21;
  P := LU[(J-1)+(J-1)*IA];
  for I:=JP1 to N do
   begin
    LU[(I-1)+(J-1)*IA] := LU[(I-1)+(J-1)*IA]/P;
_20:
   end;
_21:
 end;
if ( IDGT = 0 ) 
 then goto _24;
P := 3*N+3;
WA := P*WREL;
if ( WA+Power(10.0e0,-IDGT) <> WA ) 
 then goto _24;
IERR := 66;
goto _23;
_22:
IERR := 65;
D1 := ZERO;
D2 := ZERO;
_23:
_24:
end;

end.
